﻿using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web.Http;
using SyncfusionBase.Models;

namespace SyncfusionBase.Controllers.API
{
    public class OrdersViewController : ApiController
    {
        public NorthwindDataContext DBContext = new NorthwindDataContext();

        [HttpGet, ActionName("byId")]
        public IEnumerable<OrdersView> GetOrdersViewById(int id)
        {
            var ordersView = DBContext.OrdersViews.Where(o => o.OrderID == id);
            if (ordersView == null)
                throw new HttpResponseException(HttpStatusCode.NotFound);

            return ordersView;
        }

        [HttpGet, ActionName("withFilter")]
        public IEnumerable<OrdersView> GetOrdersViewWithFilter(string customerID, int employeeID)
        {
            return DBContext.OrdersViews.Where(o => (o.CustomerID == customerID) && (o.EmployeeID == employeeID));
        }
    }
}
