﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Web.Mvc;
using SyncfusionBase.Models;

namespace SyncfusionBase.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            //To comment or not to comment on these lines
            //var ordersViews = new NorthwindDataContext().OrdersViews.ToList();
            //var ordersViews = new NorthwindDataContext().OrdersViews.Where(e => e.CustomerID == "Jesus").ToList();
            //To comment or not to comment on these lines

            //ViewBag.Orders = ordersViews;

            InitControls();

            return View();
        }

        [HttpPost]
        public ActionResult AplyFilter(OrdersView orders)
        {
            if (String.IsNullOrEmpty(orders.CustomerID))
            {
                var data = new NorthwindDataContext().OrdersViews.ToList();
                return Json(data);
            }
            else
            {
                var data = new NorthwindDataContext().OrdersViews.Where(e => e.CustomerID == orders.CustomerID).ToList();
                return Json(data);
            }
        }

        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            var data = new NorthwindDataContext().OrdersViews.ToList();
            var result = new DataResult {result = data.Skip(dm.Skip).Take(dm.Take).ToList(), count = data.Count()};

            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Filter(Syncfusion.JavaScript.DataManager dm)
        {
            var data = new NorthwindDataContext().OrdersViews.Where(e => e.CustomerID == "AROUT").ToList();
            var result = new DataResult { result = data.Skip(dm.Skip).Take(dm.Take).ToList(), count = data.Count() };

            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public void InitControls()
        {
            var list = new NorthwindDataContext().OrdersViews.GroupBy(ow => ow.CustomerID).Select(group => group.First());
            var items = new List<SelectListItem> { new SelectListItem {Text = "--Seleccionar--", Value = "0"} };
            var i = 0;
            foreach (var customer in list)
            {
                i++;
                items.Add(new SelectListItem {Text = customer.CustomerID, Value = i.ToString(CultureInfo.InvariantCulture)});
            }
            ViewData["Customers"] = items;

            list = new NorthwindDataContext().OrdersViews.GroupBy(ow => ow.EmployeeID).Select(group => group.First());
            items = new List<SelectListItem> { new SelectListItem { Text = "--Seleccionar--", Value = "0" } };
            i = 0;
            foreach (var customer in list)
            {
                i++;
                items.Add(new SelectListItem { Text = customer.EmployeeID.ToString(), Value = i.ToString(CultureInfo.InvariantCulture) });
            }
            ViewData["Employers"] = items;
        }

        public class DataResult
        {
            public IEnumerable<OrdersView> result { get; set; }
            public int count { get; set; }
        }
    }
}